OpenTTD: HouseResolverObject Struct Reference

OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Data Fields
HouseResolverObject Struct Reference

Resolver object to be used for houses (feature 07 spritegroups). More...

`#include <newgrf_house.h>`

Inheritance diagram for HouseResolverObject:

## Public Member Functions
| HouseResolverObject (HouseID house_id, TileIndex tile, Town *town, CallbackID callback=CBID_NO_CALLBACK, uint32 param1=0, uint32 param2=0, bool not_yet_constructed=false, uint8 initial_random_bits=0, uint32 watched_cargo_triggers=0)
| Construct a resolver for a house.
ScopeResolver * | GetScope (VarSpriteGroupScope scope=VSG_SCOPE_SELF, byte relative=0)
| Get a resolver for the scope.
Public Member Functions inherited from ResolverObject
| ResolverObject (const GRFFile *grffile, CallbackID callback=CBID_NO_CALLBACK, uint32 callback_param1=0, uint32 callback_param2=0)
| Resolver constructor.
const SpriteGroup * | Resolve ()
| Resolve SpriteGroup.
uint16 | ResolveCallback ()
| Resolve callback.
virtual const SpriteGroup * | ResolveReal (const RealSpriteGroup *group) const
| Get the real sprites of the grf.
uint32 | GetRemainingTriggers () const
| Returns the waiting triggers that did not trigger any rerandomisation.
uint32 | GetReseedSum () const
| Returns the OR-sum of all bits that need reseeding independent of the scope they were accessed with.
void | ResetState ()
| Resets the dynamic state of the resolver object.

## Data Fields
HouseScopeResolver | house_scope
TownScopeResolver | town_scope
Data Fields inherited from ResolverObject
ScopeResolver | default_scope
| Default implementation of the grf scope.
CallbackID | callback
| Callback being resolved.
uint32 | callback_param1
| First parameter (var 10) of the callback.
uint32 | callback_param2
| Second parameter (var 18) of the callback.
uint32 | last_value
| Result of most recent DeterministicSpriteGroup (including procedure calls)
uint32 | waiting_triggers
| Waiting triggers to be used by any rerandomisation. (scope independent)
uint32 | used_triggers
| Subset of cur_triggers, which actually triggered some rerandomisation. (scope independent)
uint32 | reseed [VSG_END]
| Collects bits to rerandomise while triggering triggers.
const GRFFile * | grffile
| GRFFile the resolved SpriteGroup belongs to.
const SpriteGroup * | root_spritegroup
| Root SpriteGroup to use for resolving.

## Detailed Description

Resolver object to be used for houses (feature 07 spritegroups).

Definition at line 53 of file newgrf_house.h.

## Constructor & Destructor Documentation

HouseResolverObject::HouseResolverObject | ( | HouseID | house_id,
|  | TileIndex | tile,
|  | Town * | town,
|  | CallbackID | callback = `CBID_NO_CALLBACK`,
|  | uint32 | param1 = `0`,
|  | uint32 | param2 = `0`,
|  | bool | not_yet_constructed = `false`,
|  | uint8 | initial_random_bits = `0`,
|  | uint32 | watched_cargo_triggers = `0`
| ) |  |

Construct a resolver for a house.

Parameters

  house_id | House to query.
  tile | Tile containing the house.
  town | Town containing the house.
  callback | Callback ID.
  param1 | First parameter (var 10) of the callback.
  param2 | Second parameter (var 18) of the callback.
  not_yet_constructed | House is still under construction.
  initial_random_bits | Random bits during construction checks.
  watched_cargo_triggers | Cargo types that triggered the watched cargo callback.

Definition at line 57 of file newgrf_house.cpp.

References HouseSpec::grf_prop, ResolverObject::root_spritegroup, and GRFFilePropsBase< Tcnt >::spritegroup.

## Member Function Documentation

ScopeResolver* HouseResolverObject::GetScope | ( | VarSpriteGroupScope | scope = `VSG_SCOPE_SELF`,
|  | byte | relative = `0`
| ) |  |
| inlinevirtual

Get a resolver for the scope.

Parameters

  scope | Scope to return.
  relative | Additional parameter for VSG_SCOPE_RELATIVE.

Returns
  The resolver for the requested scope.

Reimplemented from ResolverObject.

Definition at line 61 of file newgrf_house.h.

References VSG_SCOPE_PARENT, and VSG_SCOPE_SELF.

The documentation for this struct was generated from the following files:

- src/newgrf_house.h
- src/newgrf_house.cpp